<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>stats - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="file.html">file</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="file.html#.readDir">readDir</a></li><li data-type='method' style='display: none;'><a href="file.html#.getFileTime">getFileTime</a></li><li data-type='method' style='display: none;'><a href="file.html#.path">path</a></li><li data-type='method' style='display: none;'><a href="file.html#.exists">exists</a></li><li data-type='method' style='display: none;'><a href="file.html#.load">load</a></li><li data-type='method' style='display: none;'><a href="file.html#.save">save</a></li><li data-type='method' style='display: none;'><a href="file.html#.gnuplot">gnuplot</a></li></ul></li><li><a href="http.html">http</a></li><li><a href="python.html">python</a></li><li><a href="regex.html">regex</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="regex.html#.regexMatch">regexMatch</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexIndexes">regexIndexes</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexReplace">regexReplace</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexSplit">regexSplit</a></li></ul></li><li><a href="stats.html">stats</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="stats.html#.random">random</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getStat">getStat</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getStatValue">getStatValue</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getDivergence">getDivergence</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotHistogram">plotHistogram</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotStatCurve">plotStatCurve</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotStatBoxes">plotStatBoxes</a></li></ul></li><li><a href="std.html">std</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="std.html#.echo">echo</a></li><li data-type='method' style='display: none;'><a href="std.html#.alert">alert</a></li><li data-type='method' style='display: none;'><a href="std.html#.argv">argv</a></li><li data-type='method' style='display: none;'><a href="std.html#.system">system</a></li><li data-type='method' style='display: none;'><a href="std.html#.wfork">wfork</a></li><li data-type='method' style='display: none;'><a href="std.html#.wfork">wfork</a></li></ul></li><li><a href="time.html">time</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="time.html#.sleep">sleep</a></li><li data-type='method' style='display: none;'><a href="time.html#.now">now</a></li><li data-type='method' style='display: none;'><a href="time.html#.nowISO">nowISO</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">stats</h1>
    

    




<section>

<header>
    
        <h2>
        
            stats
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="stats"><span class="type-signature"></span>factory stats<span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Specifies some utility for statistics.</p>
<ul>
<li>These functions are accessible via the <code>aidesys::</code> prefix.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id=".random"><span class="type-signature type-signature-static">(static) </span>random<span class="signature">(what<span class="signature-attributes">opt</span>, degree<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a deterministic pseudo-random number.</p>
<ul>
<li>This function is accessible via the <code>aidesys::</code> prefix.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>what</code></td>
            

            <td class="type">
            
                
<span class="param-type">char</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>'i'</code>
                
                </td>
            

            <td class="description last"><p>Random distribution.</p>
<ul>
<li>'u', &quot;uniform&quot;: drawn from a uniform distribution in [0, 1] (degree is not used).</li>
<li>'n', &quot;normal&quot;:  drawn from a Gaussian normal distribution (degree is not used).</li>
<li>'g', &quot;gamma&quot;:   drawn from a Gamma distribution, of a given degree.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>degree</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>1</code>
                
                </td>
            

            <td class="description last"><p>The Gamma distribution degree, usually 1, 2, 5 or 10.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A random number.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".getStat"><span class="type-signature type-signature-static">(static) </span>getStat<span class="signature">(data, length, histo<span class="signature-attributes">opt</span>, hsize<span class="signature-attributes">opt</span>, mask<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {string}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Computes usual 1D statistics returned as a parsable weak json string.</p>
<p><em>0X1</em> As a function of the sample momenta:</p>
<ul>
<li><em>&quot;count&quot;</em>: the number of observed values.</li>
<li><em>&quot;min&quot;</em>: the observed minimal value.</li>
<li><em>&quot;max&quot;</em>: the observed maximal value.</li>
<li><em>&quot;mean&quot;</em>: the mean value.</li>
<li><em>&quot;stdev&quot;</em>: the standard-deviation. (2nd order).
<ul>
<li>Returns an unbiased estimator of the theoretical standard-deviation <code>E[(x-m)^2]^(1/2)</code> (Any standard-deviation lower than DBL_EPSILON (1e-15) is set to 0).</li>
</ul>
</li>
<li>_&quot;skew&quot;  : the skewness (3rd order).
<ul>
<li>Returns an estimator of the theoretical skewness <a href="http://en.wikipedia.org/wiki/Skewness"> skewness</a> <code>E[(x - m)^3 / stdev^3]</code> (Skewness is zero for symmetric distributions).</li>
</ul>
</li>
<li>_&quot;kurt&quot;  : the kurtosis (4th order).
<ul>
<li>An estimator of the theoretical kurtosis <a href="http://en.wikipedia.org/wiki/Kurtosis">kurtosis</a> <code>E[(x - m)^4 / stdev^4] - 3</code> (Kurtosis is equal to 0 for the Gaussian distribution).</li>
</ul>
</li>
</ul>
<p><em>0X2</em> As a function of the sample momenta, with respect to usual distributions:</p>
<ul>
<li><em>&quot;gamma-degree&quot;</em>: the degree of a Gamma distribution, with the same mean and variance as the empirical distribution.
<ul>
<li>Returns the degree <code>d &gt;= 1</code> or <code>0</code> if undefined, assuming that the probability distribution has the form <br/><code>p(t) = (t / tau)^(d - 1) exp(-t / tau) / (tau d!)</code> e.g., <code>d = 1</code> for a Poisson distribution.</li>
</ul>
</li>
<li>_&quot;gamma-rate&quot;   : the rate of a Gamma distribution, with the same mean and variance as the empirical distribution.
<ul>
<li>Returns the rate <code>tau &gt;= 1</code> or <code>0</code> if undefined, assuming a Gamma distribution as above.</li>
</ul>
</li>
<li><em>&quot;uniform-entropy&quot;</em>: the entropy of a uniform distribution with the same mean and variance.</li>
<li><em>&quot;normal-entropy&quot;</em>: the entropy of a Gaussian distribution with the same mean and variance.</li>
</ul>
<p><em>0X4</em> As a function of the histogram:</p>
<ul>
<li><em>&quot;hsize&quot;</em>: the histogram sampling size.</li>
<li><em>&quot;hsize_from_standard_deviation&quot;</em>: the histogram sampling size, according to <a href="https://www.fmrib.ox.ac.uk/datasets/techrep/tr00mj2/tr00mj2/node24.html">(Scott 1979)</a>.</li>
<li><em>&quot;hsize_from_inter_quartile_range</em>: the histogram sampling size, according to <a href="https://www.fmrib.ox.ac.uk/datasets/techrep/tr00mj2/tr00mj2/node24.html">(Izenman 1991)</a>.</li>
<li><em>&quot;mode&quot;</em>: the mode value, i.e. the most frequent value, with 2nd order interpolation.</li>
<li>_&quot;median&quot;, _&quot;lower-quartile&quot;, <em>&quot;upper-quartile&quot;</em>, <em>&quot;inter-quartile-range&quot;</em>: The median corresponds to the percentile for at 50%. The quartiles to the percentile at 25% and 75%. Values are calculated from the histogram with 1st order interpolation.</li>
<li><em>&quot;median</em>&quot;, <em>&quot;lower-quartile</em>&quot;, <em>&quot;upper-quartile</em>&quot;<em>, <em>&quot;inter-quartile-range</em>&quot;</em>: Here, values are calculated from the sorted data.</li>
<li><em>&quot;entropy&quot;</em>: The distribution entropy, in bits.
<ul>
<li>We use the approximation: <br><code>-sum_i p_i log_2(p_i) + log_2(epsilon)</code>,<br> where <code>p_i</code> is the probability of the <code>i</code>-th box of size <code>epsilon</code>.</li>
</ul>
</li>
</ul>
<p><em>0X8</em> As a function of the histogram, with respect to usual distributions:</p>
<ul>
<li><em>&quot;uniform-divergence&quot;</em>: The Kullback-Leibler divergence between the empirical distribution and a uniform distribution having the same mean and variance.</li>
<li><em>&quot;normal-divergence&quot;</em>: The Kullback-Leibler divergence between the empirical distribution and a Gaussian distribution having the same mean and variance.</li>
<li><em>&quot;gamma-1-divergence&quot;</em>: The Kullback-Leibler divergence between the empirical distribution and a Gamma distribution of degree <code>1</code> having the same mean and variance.</li>
<li><em>&quot;gamma-2-divergence&quot;</em>: The Kullback-Leibler divergence between the empirical distribution and a Gamma distribution of degree <code>2</code> having the same mean and variance.</li>
<li><em>&quot;gamma-5-divergence&quot;</em>: The Kullback-Leibler divergence between the empirical distribution and a Gamma distribution of degree <code>5</code> having the same mean and variance.</li>
<li><em>&quot;gamma-10-divergence&quot;</em>: The Kullback-Leibler divergence between the empirical distribution and a Gamma distribution of degree <code>10</code> having the same mean and variance.</li>
<li><em>&quot;best-model&quot;</em>: Using the following numerical code:
<code>0</code>: &quot;normal&quot;,
<code>1</code>, <code>2</code>, <code>5, </code>10<code>: &quot;gamma-1&quot;, &quot;gamma-2&quot;, &quot;gamma-5&quot;, &quot;gamma-10&quot;, </code>-1`: &quot;uniform&quot; as a fallback option.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>data</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>
|

<span class="param-type">Vector</span>
|

<span class="param-type">function</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The 1D data.</p>
<ul>
<li>It can be provided as a <code>double[]</code> array  or a <code>std::vector&lt;double&gt;</code> buffer.</li>
<li>It also can be given as <code>double data()</code> random function or as a lambda: <br/><code>aidesys::getStat([] () { return aidesys::random('g', 10); }, 1000);</code></li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>length</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The data length, if given as an array or density function.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>histo</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>An optional <code>unsigned int[]</code> histogram buffer to return histogram values between min and max.</p>
<ul>
<li>The used size is always below the data <code>length</code>.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>hsize</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>An optional histogram size to compute histogram based values between min and max. If not specified but the mask includes estimation based on an histogram, an optimal size is calculated as the maximum between the  <a href="https://www.fmrib.ox.ac.uk/datasets/techrep/tr00mj2/tr00mj2/node24.html">(Scott 1979)</a> and <a href="https://www.fmrib.ox.ac.uk/datasets/techrep/tr00mj2/tr00mj2/node24.html">(Izenman 1991)</a> estimation, with a fallback to 100, if estimations fails.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>mask</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0xF</code>
                
                </td>
            

            <td class="description last"><p>An optional mask to deselect some calculation:</p>
<ul>
<li><em>0X1</em> As a function of the sample momenta.</li>
<li><em>0X2</em> As a function of the sample momenta, with respect to usual distributions.</li>
<li><em>0X4</em> As a function of the histogram.</li>
<li><em>0X8</em> As a function of the histogram, with respect to usual distributions.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The 1D statistics parameters returned as a parsable JSON string.</p>
<ul>
<li>The following construct allows to extract a given parameter:<br/>
<code>[getStatValue](.#getStatValue)(name, getStat(../..))</code></li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">string</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".getStatValue"><span class="type-signature type-signature-static">(static) </span>getStatValue<span class="signature">(name, stat, The)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Extract a getStat value from the JSON string.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>name</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The parameter name.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>stat</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The <a href="#.getStat">getStat</a> string returned value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>The</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>related parameter value, or <code>NAN</code> if not a number.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".getDivergence"><span class="type-signature type-signature-static">(static) </span>getDivergence<span class="signature">(data1, data2, hsize)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Calculates the Kullback-Leibler divergence between this empirical distribution and another probality density.</p>
<ul>
<li>The <a href="http://en.wikipedia.org/wiki/Kullback-Leibler_divergence">Kullback–Leibler divergence</a> <code>d(p||q) = &gt;_w p ln(p/q)</code>, where <code>p</code> is the empirical distribution and <code>q</code> the model distribution corresponds to the average number of bits difference when coding <code>p</code> with <code>q</code>.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>data1</code></td>
            

            <td class="type">
            
                
<span class="param-type">Histogram</span>
|

<span class="param-type">Array</span>
|

<span class="param-type">Vector</span>
|

<span class="param-type">function</span>



            
            </td>

            

            

            <td class="description last"><p>The 1D data empirical data.</p>
<ul>
<li>It can be provided as a <code>unsigned int[]</code> array corresponding to the data histogram.</li>
<li>It also can be provided as a <code>double[]</code> array  or a <code>std::vector&lt;double&gt;</code> buffer or <code>double p()</code> random function or lambda.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>data2</code></td>
            

            <td class="type">
            
                
<span class="param-type">Histogram</span>
|

<span class="param-type">Array</span>
|

<span class="param-type">Vector</span>
|

<span class="param-type">function</span>



            
            </td>

            

            

            <td class="description last"><p>The 1D model distribution data.</p>
<ul>
<li>It can be provided as a <code>unsigned int[]</code> array corresponding to the data histogram.</li>
<li>It alo can be provided as a <code>double[]</code> array  or a <code>std::vector&lt;double&gt;</code> buffer or <code>double p()</code> random function or lam   * @param {uint} length The data length, if given as arrays or density functions.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>hsize</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The histogram size.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The Kullback-Leibler divergence in bits.</p>
</div>



    



        
            

    

    <h4 class="name" id=".plotHistogram"><span class="type-signature type-signature-static">(static) </span>plotHistogram<span class="signature">(file, stat, histo, model)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Plots an histogram, as exemplified here:</p>
<center><img height='300' src='statsdemo/normal0.png'></center></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>file</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The plot base name, storing in <code>$file(.png|.dat|.gnuplot.sh)</code>, as documented for <a href="./file.html#.gnuplot">gnuplot</a>.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>stat</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>A string with the data statistics as provided by <a href="#getStat"><code>getStat</code></a>.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>histo</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>



            
            </td>

            

            

            <td class="description last"><p>The histogram buffer which size id defined by <code>getStatValue(&quot;hsize&quot;, stat)</code>.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>model</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            

            

            <td class="description last"><p>If true also draw the best model adjustment.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".plotStatCurve"><span class="type-signature type-signature-static">(static) </span>plotStatCurve<span class="signature">(file, means, stdevs<span class="signature-attributes">opt</span>, x0<span class="signature-attributes">opt</span>, x1<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Plots means and standard deviations as a curve, as exemplified here:</p>
<center><img height='300' src='statsdemo/normal1.png'></center></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>file</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The plot base name, storing in <code>$file(.png|.dat|.gnuplot.sh)</code>, as documented for <a href="./file.html#.gnuplot">gnuplot</a>.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>means</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>A <code>std::vector&lt;double&gt;</code> of mean values.</p>
<ul>
<li>A <code>std::vector&lt;std::string&gt;</code> of <a href="#.getStat">getStat</a> strings.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>stdevs</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>An optional <code>std::vector&lt;double&gt;</code> of standard-deviation values.</p>
<ul>
<li>If ommited a simple curve is drawn.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>x0</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>The abcissa of means.at(0);</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>x1</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>-1</code>
                
                </td>
            

            <td class="description last"><p>The abcissa of means.at(means.size()-1)., The <code>-1</code> value stands for <code>x1 = means.size()-1</code>.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".plotStatBoxes"><span class="type-signature type-signature-static">(static) </span>plotStatBoxes<span class="signature">(file, An)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Plots means and standard deviations as statistical boxes, as exemplified here:</p>
<center><img height='300' src='statsdemo/normal2.png'></center></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>file</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The plot base name, storing in <code>$file(.png|.dat|.gnuplot.sh)</code>, as documented for <a href="./file.html#.gnuplot">gnuplot</a>.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>An</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>



            
            </td>

            

            

            <td class="description last"><p><code>std::map&lt;std::string, std::string &gt;</code> of named <a href="#.getStat">getStat</a> strings, i.e., <a href="#.getStat">getStat</a> strings indexed by names.</p></td>
        </tr>

    
    </tbody>
</table>



















        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>